diff -crN nakedmudv1.0/src/mud.h nakedmudv1.4/src/mud.h
*** nakedmudv1.0/src/mud.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/mud.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 24,29 ****
--- 24,33 ----
  #define MODULE_OLC
  #define MODULE_TIME
  #define MODULE_SCRIPTS
+ #define MODULE_ALIAS
+ #define MODULE_CHAR_VARS
+ #define MODULE_SOCIALS
+ 
  
  //
  // Two modules that I am working on... together, they work similar to KaVir's
***************
*** 221,233 ****
    char           * buf;     /* the buffer it should be stored in        */
  };
  
! #define COMMAND(name)      void name(CHAR_DATA *ch, char *arg, int subcmd)
  void init_commands();
! void show_commands(CHAR_DATA *ch);
  void remove_cmd   (const char *cmd);
  void add_cmd      (const char *cmd, const char *sort_by, void *func, 
  	           int subcmd, int min_pos, int max_pos,
! 	           int min_level, bool interrupts);
  
  
  struct buffer_type
--- 225,242 ----
    char           * buf;     /* the buffer it should be stored in        */
  };
  
! 
! #define CMD_PTR(name)      void (* name)(CHAR_DATA *ch, const char *cmd, \
! 					 int subcmd, char *arg)
! #define COMMAND(name)      void name(CHAR_DATA *ch, const char *cmd, \
! 				     int subcmd, char *arg)
  void init_commands();
! void show_commands(CHAR_DATA *ch, int min_lev, int max_lev);
  void remove_cmd   (const char *cmd);
  void add_cmd      (const char *cmd, const char *sort_by, void *func, 
  	           int subcmd, int min_pos, int max_pos,
! 	           int min_level, bool mob_ok, bool interrupts);
! void remove_cmd   (const char *cmd);
  
  
  struct buffer_type
***************
*** 311,320 ****
  				bool scripts_ok, bool aliases_ok);
  
  /* io.c */
! void    log_string            ( const char *txt, ... );
! void    bug                   ( const char *txt, ... );
  time_t  last_modified         ( char *helpfile );
! char   *read_help_entry       ( const char *helpfile );     /* pointer        */
  char   *fread_line            ( FILE *fp );                 /* pointer        */
  char   *fread_string          ( FILE *fp );                 /* allocated data */
  char   *fread_word            ( FILE *fp );                 /* pointer        */
--- 320,330 ----
  				bool scripts_ok, bool aliases_ok);
  
  /* io.c */
! void    log_string            ( const char *txt, ... ) __attribute__ ((format (printf, 1, 2)));
! void    bug                   ( const char *txt, ... ) __attribute__ ((format (printf, 1, 2)));
  time_t  last_modified         ( char *helpfile );
! char   *read_file             ( const char *file );
! char   *read_help_entry       ( const char *helpfile);
  char   *fread_line            ( FILE *fp );                 /* pointer        */
  char   *fread_string          ( FILE *fp );                 /* allocated data */
  char   *fread_word            ( FILE *fp );                 /* pointer        */
***************
*** 323,328 ****
--- 333,339 ----
  
  /* strings.c */
  char   *one_arg               ( char *fStr, char *bStr );
+ void    arg_num               ( const char *from, char *to, int num); 
  bool    compares              ( const char *aStr, const char *bStr );
  bool    is_prefix             ( const char *aStr, const char *bStr );
  char   *capitalize            ( char *txt );
***************
*** 331,345 ****
  void    __buffer_strcat       ( BUFFER *buffer, const char *text );
  void    buffer_free           ( BUFFER *buffer );
  void    buffer_clear          ( BUFFER *buffer );
! int     bprintf               ( BUFFER *buffer, char *fmt, ... );
  const char *buffer_string     ( BUFFER *buffer );
  void    buffer_format         ( BUFFER *buffer, bool indent );
  
- /* help_new.c */
- bool  check_help              ( CHAR_DATA *dMob, char *helpfile );
- void  load_helps              ( void );
- void  add_help                ( HELP_DATA *help );
- 
  /* mccp.c */
  bool  compressStart     ( SOCKET_DATA *dsock, unsigned char teleopt );
  bool  compressEnd       ( SOCKET_DATA *dsock, unsigned char teleopt, bool forced );
--- 342,351 ----
  void    __buffer_strcat       ( BUFFER *buffer, const char *text );
  void    buffer_free           ( BUFFER *buffer );
  void    buffer_clear          ( BUFFER *buffer );
! int     bprintf               ( BUFFER *buffer, char *fmt, ... ) __attribute__ ((format (printf, 2, 3)));
  const char *buffer_string     ( BUFFER *buffer );
  void    buffer_format         ( BUFFER *buffer, bool indent );
  
  /* mccp.c */
  bool  compressStart     ( SOCKET_DATA *dsock, unsigned char teleopt );
  bool  compressEnd       ( SOCKET_DATA *dsock, unsigned char teleopt, bool forced );
***************
*** 355,360 ****
--- 361,368 ----
  void  page_continue         ( SOCKET_DATA *dsock);
  void  page_back             ( SOCKET_DATA *dsock);
  
+ /* help.c */
+ bool check_help(CHAR_DATA *dMob, char *helpfile);
  
  /*******************************
   * End of prototype declartion *
diff -crN nakedmudv1.0/src/object.c nakedmudv1.4/src/object.c
*** nakedmudv1.0/src/object.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/object.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 2,9 ****
  //
  // object.c
  //
! // this contains the implementation of object_data, and all of the functions
! // needed to interact with it.
  //
  //*****************************************************************************
  #include "mud.h"
--- 2,14 ----
  //
  // object.c
  //
! // this contains the basic implementation of the object data structure, and all
! // of the functions needed to interact with it. If you plan on adding any other
! // information to objects, it is strongly suggested you do so through auxiliary
! // data (see auxiliary.h).
! //
! // For a recap, IF YOU PLAN ON ADDING ANY OTHER INFORMATION TO OBJECTS, IT
! // IS STRONGLY SUGGESTED YOU DO SO THROUGH AUXILIARY DATA (see auxiliary.h).
  //
  //*****************************************************************************
  #include "mud.h"
diff -crN nakedmudv1.0/src/object.h nakedmudv1.4/src/object.h
*** nakedmudv1.0/src/object.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/object.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 4,16 ****
  //
  // object.h
  //
! // this is the main interface for working with objects (swords, staves, etc..)
! // contains all of the functions for interacting with the datastructure.
  //
  //*****************************************************************************
  
- 
- 
  OBJ_DATA    *newObj         ();
  void         deleteObj      (OBJ_DATA *obj);
  
--- 4,19 ----
  //
  // object.h
  //
! // Contains the basic interface for working with the object data structure, and
! // the functions needed to interact with it. If you plan on adding any other
! // information to objects, it is strongly suggested you do so through auxiliary
! // data (see auxiliary.h).
! //
! // For a recap, IF YOU PLAN ON ADDING ANY OTHER INFORMATION TO OBJECTS, IT
! // IS STRONGLY SUGGESTED YOU DO SO THROUGH AUXILIARY DATA (see auxiliary.h).
  //
  //*****************************************************************************
  
  OBJ_DATA    *newObj         ();
  void         deleteObj      (OBJ_DATA *obj);
  
***************
*** 81,86 ****
--- 84,90 ----
  void         objPrintBits     (OBJ_DATA *obj, int field, char *buf);
  const char  *objBitGetName    (int field, int bit);
  
+ 
  //*****************************************************************************
  //
  // Bitfields and their bits
***************
*** 96,101 ****
  #define BITFIELD_WORN             2
  #define NUM_WORN_BITS             0
  
- 
- 
  #endif // __OBJECT_H
--- 100,103 ----
diff -crN nakedmudv1.0/src/olc/dedit.c nakedmudv1.4/src/olc/dedit.c
*** nakedmudv1.0/src/olc/dedit.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/olc/dedit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,326 ----
+ //*****************************************************************************
+ //
+ // dialog_edit.c
+ //
+ // the functions needed for dialog editing in olc.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../socket.h"
+ #include "../utils.h"
+ #include "../dialog.h"
+ 
+ #include "olc.h"
+ 
+ 
+ #define EDITING_NEW_RESPONSE      "new_response"
+ 
+ 
+ //*****************************************************************************
+ //
+ // extra description sets
+ //
+ //*****************************************************************************
+ void dedit_menu(SOCKET_DATA *sock, OLC_DATA *olc) {
+   DIALOG_DATA *dialog = olcGetData(olc);
+   int i, entries = dialogGetSize(dialog);
+   int half_entries = entries/2 + (entries % 2 == 1);
+   // entries are printed side by side... these are used to hold 'em
+   char left_buf[SMALL_BUFFER];
+   char right_buf[SMALL_BUFFER];
+ 
+ 
+   send_to_socket(sock,
+                  "\033[H\033[J"
+ 		 "{gN) Dialog name\r\n"
+ 		 "{c%s\r\n"
+ 		 "{gG) Greet/Approach message\r\n"
+ 		 "{c%s\r\n"
+ 		 "\r\n"
+ 		 "{gResponse Entries: {c%d\r\n", 
+ 		 dialogGetName(dialog), 
+ 		 (*dialogGetGreet(dialog) ? dialogGetGreet(dialog) : "<NONE>"), 
+ 		 entries);
+ 
+   // print out responses, two to a line
+   for(i = 0; i < half_entries; i++) {
+     RESPONSE_DATA *left_entry = dialogGetNum(dialog, i);
+     sprintf(left_buf, "  {g%2d) {c%s", i, responseGetKeywords(left_entry));
+     if(i + half_entries < entries) {
+       RESPONSE_DATA *right_entry = dialogGetNum(dialog, i + half_entries);
+       sprintf(right_buf, "  {g%2d) {c%s", 
+ 	      i + half_entries, responseGetKeywords(right_entry));
+     }
+     else
+       *right_buf = '\0';
+ 
+     send_to_socket(sock, "%-35s %s\r\n", left_buf, right_buf);
+   }
+ 
+   send_to_socket(sock,
+ 		 "\r\n"
+ 		 "{gA) Add response\r\n"
+ 		 "{gR) Remove response\r\n"
+ 		 "Enter number to edit a specific entry\r\n"
+ 		 "\r\n"
+ 		 "{gEnter choice (Q to quit) : "
+ 		 );
+ }
+ 
+ 
+ void dedit_main_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   int next_substate = DEDIT_MAIN;
+ 
+   switch(toupper(*arg)) {
+   case 'Q':
+     send_to_socket(sock, "Save changes (Y/N) : ");
+     next_substate = DEDIT_CONFIRM_SAVE;
+     break;
+ 
+   case 'A': {
+     olcSetNext(olc, newOLC(OLC_RESPEDIT, RESPEDIT_MAIN,
+ 			   newResponse("", ""), strdup(EDITING_NEW_RESPONSE)));
+     next_substate = DEDIT_ENTRY;
+     break;
+   }
+ 
+   case 'R':
+     send_to_socket(sock, "Which response do you want to delete : ");
+     next_substate = DEDIT_DELETE;
+     break;
+ 
+   case 'N':
+     send_to_socket(sock, "Enter new name : ");
+     next_substate = DEDIT_NAME;
+     break;
+ 
+   case 'G':
+     send_to_socket(sock, "Enter new greeting : ");
+     next_substate = DEDIT_GREET;
+     break;
+ 
+   default:
+     // see if maybe they're trying to choose a description to edit
+     if(!isdigit(*arg))
+       dedit_menu(sock, olc);
+     else {
+       int num = atoi(arg);
+       RESPONSE_DATA *resp = dialogGetNum((DIALOG_DATA *)olcGetData(olc), num);
+       // if the one found is null, just show the menu
+       if(resp == NULL)
+ 	dedit_menu(sock, olc);
+       else {
+ 	olcSetNext(olc, newOLC(OLC_RESPEDIT, RESPEDIT_MAIN, 
+ 			       responseCopy(resp), strdup(arg)));
+ 	next_substate = DEDIT_ENTRY;
+ 	break;
+       }
+     }
+     break;
+   }
+   olcSetSubstate(olc, next_substate);
+ }
+ 
+ 
+ void dedit_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   int next_substate = DEDIT_MAIN;
+ 
+   switch(olcGetSubstate(olc)) {
+     /******************************************************/
+     /*                     MAIN MENU                      */
+     /******************************************************/
+   case DEDIT_MAIN:
+     dedit_main_loop(sock, olc, arg);
+     return;
+ 
+ 
+     /******************************************************/
+     /*                    CONFIRM SAVE                    */
+     /******************************************************/
+   case DEDIT_CONFIRM_SAVE:
+     switch(*arg) {
+     case 'y':
+     case 'Y':
+       olcSetSave(olc, TRUE);
+       // fall through
+     case 'n':
+     case 'N':
+       olcSetComplete(olc, TRUE);
+       return;
+     default:
+       send_to_socket(sock, "Please enter Y or N : ");
+       next_substate = DEDIT_CONFIRM_SAVE;
+       break;
+     }
+     break;
+ 
+ 
+     /******************************************************/
+     /*                      SET VALUES                    */
+     /******************************************************/
+   case DEDIT_ENTRY:
+     // save the changes we made
+     if(olcGetSave(olcGetNext(olc))) {
+       DIALOG_DATA  *dialog   = (DIALOG_DATA *)olcGetData(olc);
+       RESPONSE_DATA *entry   = (RESPONSE_DATA *)olcGetData(olcGetNext(olc));
+ 
+       if(!strcmp(EDITING_NEW_RESPONSE, (olcGetArgument(olcGetNext(olc)))))
+ 	dialogPut(dialog, responseCopy(entry));
+       else {
+ 	int num = atoi(olcGetArgument(olcGetNext(olc)));
+ 	responseCopyTo(entry, dialogGetNum(dialog, num));
+       }
+     }
+     olcSetNext(olc, NULL);
+     next_substate = DEDIT_MAIN;
+     break;
+ 
+   case DEDIT_DELETE: {
+     int num = atoi(arg);
+     RESPONSE_DATA *entry = ((RESPONSE_DATA *)
+ 			    dialogGetNum((DIALOG_DATA *)olcGetData(olc), num));
+     if(entry) {
+       dialogRemove((DIALOG_DATA *)olcGetData(olc), entry);
+       deleteResponse(entry);
+     }
+     next_substate = DEDIT_MAIN;
+     break;
+   }
+ 
+   case DEDIT_NAME:
+     dialogSetName((DIALOG_DATA *)olcGetData(olc), arg);
+     next_substate = DEDIT_MAIN;
+     break;
+ 
+   case DEDIT_GREET:
+     dialogSetGreet((DIALOG_DATA *)olcGetData(olc), arg);
+     next_substate = DEDIT_MAIN;
+     break;
+ 
+     /******************************************************/
+     /*                        DEFAULT                     */
+     /******************************************************/
+   default:
+     log_string("ERROR: Performing dedit with invalid substate.");
+     send_to_socket(sock, "An error occured while you were in OLC.\r\n");
+     socketSetOLC(sock, NULL);
+     socketSetState(sock, STATE_PLAYING);
+     return;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+   if(next_substate == DEDIT_MAIN)
+     dedit_menu(sock, olc);
+ }
+ 
+ 
+ //*****************************************************************************
+ //
+ // single response editing
+ //
+ //*****************************************************************************
+ void respedit_menu(SOCKET_DATA *sock, OLC_DATA *olc) {
+   RESPONSE_DATA *response = (RESPONSE_DATA *)olcGetData(olc);
+ 
+   send_to_socket(sock,
+                  "\033[H\033[J"
+ 		 "{g1) Keywords\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g2) Message\r\n"
+ 		 "{c%s\r\n"
+ 		 "{gEnter choice (Q to quit) : ",
+ 		 responseGetKeywords(response), 
+ 		 responseGetMessage(response)
+ 		 );
+ }
+ 
+ 
+ void respedit_main_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   int next_substate = RESPEDIT_MAIN;
+ 
+   switch(*arg) {
+   case 'q':
+   case 'Q':
+     send_to_socket(sock, "Save changes (Y/N) : ");
+     next_substate = RESPEDIT_CONFIRM_SAVE;
+     break;
+ 
+   case '1':
+     send_to_socket(sock, "Enter new keywords : ");
+     next_substate = RESPEDIT_KEYWORDS;
+     break;
+ 
+   case '2':
+     send_to_socket(sock, "Enter new message : ");
+     next_substate = RESPEDIT_MESSAGE;
+     break;
+ 
+   default:
+     respedit_menu(sock, olc);
+     break;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+ }
+ 
+ 
+ void respedit_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   int next_substate = RESPEDIT_MAIN;
+ 
+   switch(olcGetSubstate(olc)) {
+     /******************************************************/
+     /*                     MAIN MENU                      */
+     /******************************************************/
+   case RESPEDIT_MAIN:
+     respedit_main_loop(sock, olc, arg);
+     return;
+ 
+ 
+     /******************************************************/
+     /*                    CONFIRM SAVE                    */
+     /******************************************************/
+   case RESPEDIT_CONFIRM_SAVE:
+     switch(*arg) {
+     case 'y':
+     case 'Y':
+       olcSetSave(olc, TRUE);
+       // fall through
+     case 'n':
+     case 'N':
+       olcSetComplete(olc, TRUE);
+       return;
+     default:
+       send_to_socket(sock, "Please enter Y or N : ");
+       next_substate = RESPEDIT_CONFIRM_SAVE;
+       break;
+     }
+     break;
+ 
+ 
+     /******************************************************/
+     /*                      SET VALUES                    */
+     /******************************************************/
+   case RESPEDIT_KEYWORDS:
+     responseSetKeywords((RESPONSE_DATA *)olcGetData(olc), arg);
+     break;
+   case RESPEDIT_MESSAGE:
+     responseSetMessage((RESPONSE_DATA *)olcGetData(olc), arg);
+     break;
+ 
+ 
+     /******************************************************/
+     /*                        DEFAULT                     */
+     /******************************************************/
+   default:
+     log_string("ERROR: Performing redit with invalid substate.");
+     send_to_socket(sock, "An error occured while you were in OLC.\r\n");
+     socketSetOLC(sock, NULL);
+     socketSetState(sock, STATE_PLAYING);
+     return;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+   if(next_substate == RESPEDIT_MAIN)
+     respedit_menu(sock, olc);
+ }
diff -crN nakedmudv1.0/src/olc/.depend nakedmudv1.4/src/olc/.depend
*** nakedmudv1.0/src/olc/.depend	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/olc/.depend	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,11 ----
+ dedit.o: dedit.c olc.h
+ edesc_edit.o: edesc_edit.c olc.h
+ exedit.o: exedit.c olc.h
+ medit.o: medit.c olc.h
+ oedit.o: oedit.c olc.h
+ olc.o: olc.c olc.h
+ redit.o: redit.c olc.h
+ resedit.o: resedit.c olc.h
+ scedit.o: scedit.c olc.h
+ ssedit.o: ssedit.c olc.h
+ zedit.o: zedit.c olc.h
diff -crN nakedmudv1.0/src/olc/edesc_edit.c nakedmudv1.4/src/olc/edesc_edit.c
*** nakedmudv1.0/src/olc/edesc_edit.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/olc/edesc_edit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,290 ----
+ //*****************************************************************************
+ //
+ // edesc_edit.c
+ //
+ // the functions needed for extra description/extra description set editing
+ // in olc.
+ //
+ //***************************************************************************** 
+ 
+ #include "../mud.h"
+ #include "../socket.h"
+ #include "../utils.h"
+ #include "../extra_descs.h"
+ 
+ #include "olc.h"
+ 
+ 
+ #define EDITING_NEW_EDESC      "new_edesc"
+ 
+ 
+ //*****************************************************************************
+ //
+ // extra description sets
+ //
+ //*****************************************************************************
+ void edsedit_menu(SOCKET_DATA *sock, OLC_DATA *olc) {
+   EDESC_SET *set = (EDESC_SET *)olcGetData(olc);
+   int i, entries = getEdescSetSize(set);
+ 
+   send_to_socket(sock,
+                  "\033[H\033[J"
+ 		 "{gEntries: {c%d\r\n", entries);
+ 
+   // print out each one
+   for(i = 0; i < entries; i++) {
+     EDESC_DATA *entry = getEdescNum(set, i);
+     send_to_socket(sock,
+ 		   "  {g%2d) {c%s\r\n", i, getEdescKeywords(entry));
+   }
+ 
+   send_to_socket(sock,
+ 		 "\r\n"
+ 		 "{gN) new entry\r\n"
+ 		 "{gD) delete entry\r\n"
+ 		 "Enter number to edit a specific entry\r\n"
+ 		 "\r\n"
+ 		 "{gEnter choice (Q to quit) : "
+ 		 );
+ }
+ 
+ 
+ void edsedit_main_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   int next_substate = EDSEDIT_MAIN;
+ 
+   switch(*arg) {
+   case 'q':
+   case 'Q':
+     send_to_socket(sock, "Save changes (Y/N) : ");
+     next_substate = EDSEDIT_CONFIRM_SAVE;
+     break;
+ 
+ 
+   case 'n':
+   case 'N': {
+     olcSetNext(olc, newOLC(OLC_EDEDIT, EDEDIT_MAIN,
+ 			   newEdesc("", ""), strdup(EDITING_NEW_EDESC)));
+     next_substate = EDSEDIT_ENTRY;
+     break;
+   }
+ 
+   case 'd':
+   case 'D':
+     send_to_socket(sock, "Which extra description do you want to delete : ");
+     next_substate = EDSEDIT_DELETE;
+     break;
+ 
+   default:
+     // see if maybe they're trying to choose a description to edit
+     if(!isdigit(*arg))
+       edsedit_menu(sock, olc);
+     else {
+       int num = atoi(arg);
+       EDESC_DATA *edesc = getEdescNum((EDESC_SET *)olcGetData(olc), num);
+       // if the one found is null, just show the menu
+       if(edesc == NULL)
+ 	edsedit_menu(sock, olc);
+       else {
+ 	olcSetNext(olc, newOLC(OLC_EDEDIT, EDEDIT_MAIN, 
+ 			       copyEdesc(edesc), strdup(arg)));
+ 	next_substate = EDSEDIT_ENTRY;
+ 	break;
+       }
+     }
+     break;
+   }
+   olcSetSubstate(olc, next_substate);
+ }
+ 
+ 
+ void edsedit_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   int next_substate = EDSEDIT_MAIN;
+ 
+   switch(olcGetSubstate(olc)) {
+     /******************************************************/
+     /*                     MAIN MENU                      */
+     /******************************************************/
+   case EDSEDIT_MAIN:
+     edsedit_main_loop(sock, olc, arg);
+     return;
+ 
+ 
+     /******************************************************/
+     /*                    CONFIRM SAVE                    */
+     /******************************************************/
+   case EDSEDIT_CONFIRM_SAVE:
+     switch(*arg) {
+     case 'y':
+     case 'Y':
+       olcSetSave(olc, TRUE);
+       // fall through
+     case 'n':
+     case 'N':
+       olcSetComplete(olc, TRUE);
+       return;
+     default:
+       send_to_socket(sock, "Please enter Y or N : ");
+       next_substate = EDSEDIT_CONFIRM_SAVE;
+       break;
+     }
+     break;
+ 
+ 
+     /******************************************************/
+     /*                      SET VALUES                    */
+     /******************************************************/
+   case EDSEDIT_ENTRY:
+     // save the changes we made
+     if(olcGetSave(olcGetNext(olc))) {
+       EDESC_SET  *set   = (EDESC_SET  *)olcGetData(olc);
+       EDESC_DATA *entry = (EDESC_DATA *)olcGetData(olcGetNext(olc));
+ 
+       if(!strcmp(EDITING_NEW_EDESC, (olcGetArgument(olcGetNext(olc)))))
+ 	edescSetPut(set, copyEdesc(entry));
+       else {
+ 	int num = atoi(olcGetArgument(olcGetNext(olc)));
+ 	copyEdescTo(entry, getEdescNum(set, num));
+       }
+     }
+     olcSetNext(olc, NULL);
+     next_substate = EDSEDIT_MAIN;
+     break;
+ 
+   case EDSEDIT_DELETE: {
+     int num = atoi(arg);
+     EDESC_DATA *entry = ((EDESC_DATA *)
+ 			 getEdescNum((EDESC_SET *)olcGetData(olc), num));
+     if(entry) {
+       removeEdesc((EDESC_SET *)olcGetData(olc), entry);
+       deleteEdesc(entry);
+     }
+     next_substate = EDSEDIT_MAIN;
+     break;
+   }
+ 
+     /******************************************************/
+     /*                        DEFAULT                     */
+     /******************************************************/
+   default:
+     log_string("ERROR: Performing edesc edit with invalid substate.");
+     send_to_socket(sock, "An error occured while you were in OLC.\r\n");
+     socketSetOLC(sock, NULL);
+     socketSetState(sock, STATE_PLAYING);
+     return;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+   if(next_substate == EDSEDIT_MAIN)
+     edsedit_menu(sock, olc);
+ }
+ 
+ 
+ //*****************************************************************************
+ //
+ // single extra descriptions
+ //
+ //*****************************************************************************
+ void ededit_menu(SOCKET_DATA *sock, OLC_DATA *olc) {
+   EDESC_DATA *edesc = (EDESC_DATA *)olcGetData(olc);
+ 
+   send_to_socket(sock,
+                  "\033[H\033[J"
+ 		 "{g1) Keywords\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g2) Description\r\n"
+ 		 "{c%s\r\n"
+ 		 "{gEnter choice (Q to quit) : ",
+ 		 getEdescKeywords(edesc), 
+ 		 getEdescDescription(edesc)
+ 		 );
+ }
+ 
+ 
+ void ededit_main_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   int next_substate = EDEDIT_MAIN;
+ 
+   switch(*arg) {
+   case 'q':
+   case 'Q':
+     send_to_socket(sock, "Save changes (Y/N) : ");
+     next_substate = EDEDIT_CONFIRM_SAVE;
+     break;
+ 
+   case '1':
+     send_to_socket(sock, "Enter new keywords : ");
+     next_substate = EDEDIT_KEYWORDS;
+     break;
+ 
+   case '2':
+     send_to_socket(sock, "Enter new description\r\n");
+     start_text_editor(sock, 
+ 		      getEdescPtr((EDESC_DATA *)olcGetData(olc)),
+ 		      MAX_BUFFER, EDITOR_MODE_NORMAL);
+     next_substate = REDIT_MAIN;
+     break;
+ 
+   default:
+     ededit_menu(sock, olc);
+     break;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+ }
+ 
+ 
+ void ededit_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   int next_substate = EDEDIT_MAIN;
+ 
+   switch(olcGetSubstate(olc)) {
+     /******************************************************/
+     /*                     MAIN MENU                      */
+     /******************************************************/
+   case EDEDIT_MAIN:
+     ededit_main_loop(sock, olc, arg);
+     return;
+ 
+ 
+     /******************************************************/
+     /*                    CONFIRM SAVE                    */
+     /******************************************************/
+   case EDEDIT_CONFIRM_SAVE:
+     switch(*arg) {
+     case 'y':
+     case 'Y':
+       olcSetSave(olc, TRUE);
+       // fall through
+     case 'n':
+     case 'N':
+       olcSetComplete(olc, TRUE);
+       return;
+     default:
+       send_to_socket(sock, "Please enter Y or N : ");
+       next_substate = EDEDIT_CONFIRM_SAVE;
+       break;
+     }
+     break;
+ 
+ 
+     /******************************************************/
+     /*                      SET VALUES                    */
+     /******************************************************/
+   case EDEDIT_KEYWORDS:
+     setEdescKeywords((EDESC_DATA *)olcGetData(olc), arg);
+     break;
+ 
+ 
+     /******************************************************/
+     /*                        DEFAULT                     */
+     /******************************************************/
+   default:
+     log_string("ERROR: Performing redit with invalid substate.");
+     send_to_socket(sock, "An error occured while you were in OLC.\r\n");
+     socketSetOLC(sock, NULL);
+     socketSetState(sock, STATE_PLAYING);
+     return;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+   if(next_substate == EDEDIT_MAIN)
+     ededit_menu(sock, olc);
+ }
